#ifndef _BT_TRACKER_H_
#define _BT_TRACKER_H_

#include <map>

class bt_peer;

/* The tracker class - represents a tracker */
class bt_tracker{

public:
	/* Unique id of tracker => different from peers*/
	unsigned int tracker_id;
	
	/* List of known clients */
	vector<bt_peer*> clients;
	/* to check if a client is already there or not*/
	map<bt_peer*,bool> map_clients;

	/* list to return to the peers  --- for testing the univ nodes bias case*/
	vector<bt_peer*>ret_clients;



	/* function that returns a list of peers in response to announce */
	/* this function also updates the current info stored about the peer who is sending the announce request*/
	

	bt_tracker();
	virtual vector<bt_peer*>* announce(bt_peer* in_client);
	virtual void peer_leaving(bt_peer* leaving_peer);
	virtual ~bt_tracker() {}
};

#endif /* _BT_TRACKER_H_ */
