#ifndef _BT_UPLOADER_H_
#define _BT_UPLOADER_H_


class bt_peer;
class downloader;

/* class to manage a peer's upload => only one per peer */
class uploader{
	
public:

	/* pointer to peer this uploader belongs to */
	bt_peer* peer;
	
	/* pointer to other side of connection */
	downloader* other_side;

	/* STATE VARIABLES */
	unsigned char interested ;
	unsigned char choked ;
	unsigned int ratesince_time;
	unsigned int last_time;
	unsigned int ul_rate;

	uploader(bt_peer* peer);
	
	/* function to reply to a request*/
	void got_request();

	/* function to receive a cancel message */
	void got_cancel();

	/* function to send a choke message */
	void send_choke();

	/* function to send an unchoke message */
	void send_unchoke();

	/* sends a have message to the connected downloaders*/
	void send_have(unsigned int);

	/* function to receive an 'interested' message */
	void got_interested();

	/* function to receive a 'not interested' message */
	void got_not_interested();
	
	/* function to update upload rate*/
	void update_rate(unsigned int);

	/* cleans up state associated with the downloader*/
	void cleanup_state();
	/* called up by the other side */
	void close_connection();


};

#endif
